!==============================================================================
! Simple Hello World program: OpenMP Version.
!
! Compile with:
! - gfortran -fopenmp helloworld_f90_omp-template.f90
! - ifort -openmp helloworld_f90_omp-template.f90 
!==============================================================================

program Hello_World

   use omp_lib

   implicit none
   integer, parameter :: NUM_THREADS = 4 
   integer :: ID
   integer :: nthr
   integer :: nthreads

   real(8) :: start_time, end_time, elapsed_time; ! Time variables to compute the cpu time used.

   write(*,*) 
   write(*,fmt="(a)") "Start the program."
   write(*,*) " "

   ! Set number of threads to NUM_THREADS

   ADD_OMP_DIRECTIVE_HERE 

   ! To know how many threads are available outside the parallel region.

   nthr = ADD_OMP_DIRECTIVE_HERE

   write(*,fmt="(a,I2)") "I am out of the parallel region and the number of threads is: ", nthr

   write(*,*)
   write(*,fmt="(a)") "Start of the parallel region."
   write(*,*) " "

   ! Store the time before the parallel region. 

   start_time = ADD_OMP_DIRECTIVE_HERE

   ! Add !$omp parallel to create threads

   ADD_OMP_DIRECTIVE_HERE
   
   ID = ADD_OMP_DIRECTIVE_HERE         ! To get the thread number or rank.

   nthreads = ADD_OMP_DIRECTIVE_HERE   ! To get the number of threads in the parallel region.

   write(*,fmt="(a,I2,a,I2,a)") "Hello World!, My ID is equal to [ ", ID, " ] - The total of threads is: [", nthreads, " ]"
 
   ADD_OMP_DIRECTIVE_HERE

   write(*,*) " "
   write(*,fmt="(a)") "End of the parallel region."
   write(*,*) " "

   ! Store the time after the parallel region. 

   end_time = ADD_OMP_DIRECTIVE_HERE

   ! Compute time spend in the parallel region. 

   elapsed_time = end_time - start_time

   ! Print out the time spend in the parallel region. */

   write(*,fmt="(a,f12.8,a)") "The time spend in the parallel region is: ",elapsed_time, "s"

   ! To know how many threads are available outside the parallel region.

   nthr = ADD_OMP_DIRECTIVE_HERE

   write(*,fmt="(a,I2)") "I am out of the parallel region and the number of threads is: ", nthr
   write(*,*) " "
   write(*,fmt="(a)") "End of the program."
   write(*,*) " "

end program Hello_World

!==============================================================================
! End of the program Hello World.
!==============================================================================
